function probability = alpha_pass(observations, prior, transition, observation_matrix)
N = length(prior); %number of states
T = length(observations); %observation sequence length
alphaMatrix = zeros(T, N); %T x N matrix
for col = 1:N
   alphaMatrix(1, col) = prior(col)*observation_matrix(col, observations(1)); 
end

for row = 2:T
    for col = 1:N
        total = 0;
        for index = 1:N
            total = total + alphaMatrix(row-1, index)*transition(index, col);
        end
        alphaMatrix(row, col) = total*observation_matrix(col, observations(row));
    end
end

[row col] = size(alphaMatrix);
probability = sum(alphaMatrix(row, :));