addpath('../HMMall/KPMtools','../HMMall/KPMstats');
files = dir('./concepts');
files = files(3:end);
fileCount = length(files);

for eventCounter = 1:fileCount
    load(['./concepts/' files(eventCounter).name]);
    data = dataFormat(finalResult);

    O = actionsSize; %number of observations possibilities
    Q = 5; %number of observations 

    % initial guess of parameters
    prior0 = normalise(rand(Q,1));
    transmat0 = mk_stochastic(rand(Q,Q));
    obsmat0 = mk_stochastic(rand(Q,O));

    % improve guess of parameters using EM
    [LL, prior1, transmat1, obsmat1] = dhmm_em(data, prior0, transmat0, obsmat0, 'max_iter', 5);
    LL

    % use model to compute log likelihood
    loglik = dhmm_logprob(data, prior1, transmat1, obsmat1)
    % log lik is slightly different than LL(end), since it is computed
    % after the final M step
    save(['./training data/' files(eventCounter).name], 'prior1', 'transmat1', 'obsmat1');
end
clear files fileCount eventCounter observation_sequence data O Q prior0 prior1 transmat0 transmat1 obsmat0 obsmat1 LL loglik