load('classifier_accuracy.mat'); %load up 'classifier_accuracy' and 'prob_matrices'
addpath('../HMMall/KPMtools','../HMMall/KPMstats'); %for 'normalize' function
num_models = length(prob_matrices);
num_sequences = length(prob_matrices{1});
for i=1:num_models %normalize rows of matrix
    prob_matrices{i}(:, 4:end) = normalize(prob_matrices{i}(:, 4:end),2);
end

%confidences = zeros(length(prob_matrices{1}), 2+num_models);%array to hold the confidence value from each model
confidences = zeros(length(prob_matrices{1}), 2+15);%array to hold the confidence value from each model
for i=1:num_sequences %iterate through video sequences
    for model=1:num_models %iterate through each model
        predicted = prob_matrices{model}(i, 3); %predicted event label generated by model
        ground_truth = prob_matrices{model}(i, 2);
        weight1 = classifier_accuracy{model, 2}(predicted); %weight given by confusion matrix of model
        weight2 = prob_matrices{model}(i, 3+predicted); %weight given by normalized probability across events
        confidences(i, 2+predicted) = confidences(i, 2+predicted)+weight1;
        %confidences(i, 2+model) = weight2;
    end
    [val index] = max(confidences(i, 3:end));%pick model with highest confidence
    confidences(i, 2) = index;
    %confidences(i, 1) = prob_matrices{index}(i, 3); %use overall predicted label as the one from most confident model
    confidences(i, 1) = index;
end
accuracy = sum(prob_matrices{1}(:, 2) == confidences(:, 1))/length(confidences)
confusion_matrix = confusionmat(prob_matrices{1}(:, 2), confidences(:, 1));
row_sum = sum(confusion_matrix, 2);
for i = 1:length(confusion_matrix) %normalize rows
    if row_sum(i) ~= 0    
       confusion_matrix(i, :) = confusion_matrix(i, :)/row_sum(i);
    end
end
% num_correct = zeros(7, 1);
% for i=1:num_sequences
%    num_matches = sum(prob_matrices{1}(i, 2) == confidences(i, 2:end));
%    num_correct(num_matches+1) = num_correct(num_matches+1)+1;
% end
clear i val index model num_models row_sum num_matches